/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(INDEXED_DATABASE)

#include "IDBOpenDBRequest.h"
#include "JSDOMWrapper.h"
#include "JSIDBRequest.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSIDBOpenDBRequest : public JSIDBRequest {
public:
    using Base = JSIDBRequest;
    using DOMWrapped = IDBOpenDBRequest;
    static JSIDBOpenDBRequest* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<IDBOpenDBRequest>&& impl)
    {
        JSIDBOpenDBRequest* ptr = new (NotNull, JSC::allocateCell<JSIDBOpenDBRequest>(globalObject->vm().heap)) JSIDBOpenDBRequest(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);
    static IDBOpenDBRequest* toWrapped(JSC::VM&, JSC::JSValue);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
    IDBOpenDBRequest& wrapped() const
    {
        return static_cast<IDBOpenDBRequest&>(Base::wrapped());
    }
protected:
    JSIDBOpenDBRequest(JSC::Structure*, JSDOMGlobalObject&, Ref<IDBOpenDBRequest>&&);

    void finishCreation(JSC::VM&);
};

class JSIDBOpenDBRequestOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&, const char**);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, IDBOpenDBRequest*)
{
    static NeverDestroyed<JSIDBOpenDBRequestOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(IDBOpenDBRequest* wrappableObject)
{
    return wrappableObject;
}

JSC::JSValue toJS(JSC::JSGlobalObject*, JSDOMGlobalObject*, IDBOpenDBRequest&);
inline JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, IDBOpenDBRequest* impl) { return impl ? toJS(lexicalGlobalObject, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject*, Ref<IDBOpenDBRequest>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, RefPtr<IDBOpenDBRequest>&& impl) { return impl ? toJSNewlyCreated(lexicalGlobalObject, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<IDBOpenDBRequest> {
    using WrapperClass = JSIDBOpenDBRequest;
    using ToWrappedReturnType = IDBOpenDBRequest*;
};

} // namespace WebCore

#endif // ENABLE(INDEXED_DATABASE)
