/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(WEB_AUDIO)

#include "JSAudioNode.h"
#include "JSDOMConvertEnumeration.h"
#include "JSDOMWrapper.h"
#include "OscillatorNode.h"
#include <wtf/NeverDestroyed.h>

namespace WebCore {

class JSOscillatorNode : public JSAudioNode {
public:
    using Base = JSAudioNode;
    using DOMWrapped = OscillatorNode;
    static JSOscillatorNode* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<OscillatorNode>&& impl)
    {
        JSOscillatorNode* ptr = new (NotNull, JSC::allocateCell<JSOscillatorNode>(globalObject->vm().heap)) JSOscillatorNode(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
    OscillatorNode& wrapped() const
    {
        return static_cast<OscillatorNode&>(Base::wrapped());
    }
protected:
    JSOscillatorNode(JSC::Structure*, JSDOMGlobalObject&, Ref<OscillatorNode>&&);

    void finishCreation(JSC::VM&);
};

class JSOscillatorNodeOwner : public JSC::WeakHandleOwner {
public:
    virtual bool isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown>, void* context, JSC::SlotVisitor&, const char**);
    virtual void finalize(JSC::Handle<JSC::Unknown>, void* context);
};

inline JSC::WeakHandleOwner* wrapperOwner(DOMWrapperWorld&, OscillatorNode*)
{
    static NeverDestroyed<JSOscillatorNodeOwner> owner;
    return &owner.get();
}

inline void* wrapperKey(OscillatorNode* wrappableObject)
{
    return wrappableObject;
}

JSC::JSValue toJS(JSC::JSGlobalObject*, JSDOMGlobalObject*, OscillatorNode&);
inline JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, OscillatorNode* impl) { return impl ? toJS(lexicalGlobalObject, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject*, Ref<OscillatorNode>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, RefPtr<OscillatorNode>&& impl) { return impl ? toJSNewlyCreated(lexicalGlobalObject, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<OscillatorNode> {
    using WrapperClass = JSOscillatorNode;
    using ToWrappedReturnType = OscillatorNode*;
};
String convertEnumerationToString(OscillatorNode::Type);
template<> JSC::JSString* convertEnumerationToJS(JSC::JSGlobalObject&, OscillatorNode::Type);

template<> Optional<OscillatorNode::Type> parseEnumeration<OscillatorNode::Type>(JSC::JSGlobalObject&, JSC::JSValue);
template<> const char* expectedEnumerationValues<OscillatorNode::Type>();


} // namespace WebCore

#endif // ENABLE(WEB_AUDIO)
