/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#pragma once

#if ENABLE(VIDEO_TRACK)

#include "JSDOMConvertEnumeration.h"
#include "JSDOMWrapper.h"
#include "JSTextTrackCue.h"
#include "VTTCue.h"

namespace WebCore {

class JSVTTCue : public JSTextTrackCue {
public:
    using Base = JSTextTrackCue;
    using DOMWrapped = VTTCue;
    static JSVTTCue* create(JSC::Structure* structure, JSDOMGlobalObject* globalObject, Ref<VTTCue>&& impl)
    {
        JSVTTCue* ptr = new (NotNull, JSC::allocateCell<JSVTTCue>(globalObject->vm().heap)) JSVTTCue(structure, *globalObject, WTFMove(impl));
        ptr->finishCreation(globalObject->vm());
        return ptr;
    }

    static JSC::JSObject* createPrototype(JSC::VM&, JSDOMGlobalObject&);
    static JSC::JSObject* prototype(JSC::VM&, JSDOMGlobalObject&);
    static VTTCue* toWrapped(JSC::VM&, JSC::JSValue);

    DECLARE_INFO;

    static JSC::Structure* createStructure(JSC::VM& vm, JSC::JSGlobalObject* globalObject, JSC::JSValue prototype)
    {
        return JSC::Structure::create(vm, globalObject, prototype, JSC::TypeInfo(JSC::ObjectType, StructureFlags), info());
    }

    static JSC::JSValue getConstructor(JSC::VM&, const JSC::JSGlobalObject*);
    static void analyzeHeap(JSCell*, JSC::HeapAnalyzer&);
    VTTCue& wrapped() const
    {
        return static_cast<VTTCue&>(Base::wrapped());
    }
protected:
    JSVTTCue(JSC::Structure*, JSDOMGlobalObject&, Ref<VTTCue>&&);

    void finishCreation(JSC::VM&);
};

JSC::JSValue toJS(JSC::JSGlobalObject*, JSDOMGlobalObject*, VTTCue&);
inline JSC::JSValue toJS(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, VTTCue* impl) { return impl ? toJS(lexicalGlobalObject, globalObject, *impl) : JSC::jsNull(); }
JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject*, JSDOMGlobalObject*, Ref<VTTCue>&&);
inline JSC::JSValue toJSNewlyCreated(JSC::JSGlobalObject* lexicalGlobalObject, JSDOMGlobalObject* globalObject, RefPtr<VTTCue>&& impl) { return impl ? toJSNewlyCreated(lexicalGlobalObject, globalObject, impl.releaseNonNull()) : JSC::jsNull(); }

template<> struct JSDOMWrapperConverterTraits<VTTCue> {
    using WrapperClass = JSVTTCue;
    using ToWrappedReturnType = VTTCue*;
};
String convertEnumerationToString(VTTCue::AutoKeyword);
template<> JSC::JSString* convertEnumerationToJS(JSC::JSGlobalObject&, VTTCue::AutoKeyword);

template<> Optional<VTTCue::AutoKeyword> parseEnumeration<VTTCue::AutoKeyword>(JSC::JSGlobalObject&, JSC::JSValue);
template<> const char* expectedEnumerationValues<VTTCue::AutoKeyword>();


} // namespace WebCore

#endif // ENABLE(VIDEO_TRACK)
